freeslot("sfx_tjump2", "sfx_tjump3", "sfx_spindm", "S_PLAY_FRONTFLIPO", "S_PLAY_FRONTFLIPT", "S_PLAY_SWAPJUMP")
sfxinfo[sfx_tjump2].caption = "Skip"
sfxinfo[sfx_tjump3].caption = "Hop"
sfxinfo[sfx_spindm].caption = "Re-Curl"
states[S_PLAY_FRONTFLIPO] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 8, 2, S_PLAY_SWAPJUMP}
states[S_PLAY_FRONTFLIPT] = {SPR_PLAY, SPR2_ROLL|FF_ANIMATE, 8, nil, 8, 2, S_PLAY_SPRING}
states[S_PLAY_SWAPJUMP] = {SPR_PLAY, SPR2_LAND, 8, nil, 0,  0, S_PLAY_SWAPJUMP}

//particle junk
local jumpdust = function(inflictor, ns, item)
	local i = 0
	while i < 15
		local fa = (i*(ANGLE_180/8))
		local mo = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, item)
		mo.scale = inflictor.scale
		if mo and mo.valid
			mo.momy = FixedMul(cos(fa), ns)
			mo.momx = FixedMul(sin(fa), ns)
		end
		i = $+1
	end
end

addHook("PlayerThink", function(player, musname)
	if player.mo and player.mo.valid
	and (player.mo.skin == "dummie")
		if player.powers[pw_underwater] != 0 and player.mo.eflags & MFE_UNDERWATER and not player.powers[pw_super]
			P_RestoreMusic(player)
		end
		player.powers[pw_underwater] = 0
		player.powers[pw_spacetime] = 0
	end
end)


addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.mo.skin == "dummie")
	and player.playerstate == PST_LIVE 
		if player.mo.state == S_PLAY_SWAPJUMP
			if (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.momz >= 0
				player.mo.state = S_PLAY_FALL
			end
			
			if not (player.mo.eflags & MFE_VERTICALFLIP)
			and player.mo.momz <= 0
				player.mo.state = S_PLAY_FALL
			end
		end
		
		player.cantrick = false //disable xmom tricks cause they dont wanna cooperate with me >:(
		player.spcanflip = false

		//measure jumps
		if player.jumpnumber == nil 
			player.jumpnumber = 0 
			player.justjumped = 0
			player.jumpcheck = 0
		end
		if P_IsObjectOnGround(player.mo) 
		and player.jumpcheck == 0 
			player.jumpnumber = 0 
		end
		//recurl checker for fadswap
		if player.canrecurl == nil
		or P_IsObjectOnGround(player.mo)
			player.canrecurl = 0
		end
		
		//to prevent immediate double or triple jump
		if player.usedown == nil 
		or not (player.cmd.buttons & BT_JUMP) 
			player.usedown = 0
			player.justjumped = 0 
		end
		if P_IsObjectOnGround(player.mo) 
		and (player.cmd.buttons & BT_JUMP) 
			player.usedown = 1 
		end
		
		//to prevent immediate recurl
		if player.spindown == nil 
		or not (player.cmd.buttons & BT_SPIN) 
			player.spindown = 0
		end
		if P_IsObjectOnGround(player.mo) 
		and (player.cmd.buttons & BT_SPIN) 
		or player.rings >= 50 and not player.powers[pw_super] and All7Emeralds(emeralds) //prevent transforming doing a dumb
			player.spindown = 1 
		end
				
		//----------------------------------------------------------------------
		
		if player.pflags & PF_JUMPED 
		and player.usedown == 0 
		and not (player.pflags & PF_THOKKED) 
		and player.cmd.buttons & BT_JUMP 
		and player.jumpcheck == 0 
		and not (player.exiting) 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
			player.jumpcheck = 1 
		end
			
		//jumping time, lets make sure a bunch of stuff aint happenin when we do it first		
		if not (player.pflags & PF_SPINNING) 
		and not (player.pflags & PF_STARTDASH) 
		and not (tracer and tracer.type == MT_TUBEWAYPOINT) 
		and player.jumpcheck == 1 
		and player.mo.health 
		and not (P_PlayerInPain(player)) 
		or player.jumpcheck == 1
		and not P_IsObjectOnGround(player.mo)
			
			//first jump
			if player.jumpnumber == 0 
				player.justjumped = 1 
				player.jumpnumber = 1 //you just jumped weenie congrats
				player.pflags = $1|PF_JUMPED 
				player.pflags = $1 & ~PF_SPINNING
				if player.isxmomentum
					P_SetObjectMomZ(player.mo, (player.speed/18) + (player.mo.momz))
				end
			end
			
			//second jump
			if player.jumpnumber == 1 
			and player.justjumped == 0 
			and not (P_PlayerInPain(player)) 
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
			and not P_IsObjectOnGround(player.mo)
				player.justjumped = 1 
				player.jumpnumber = 2 
				player.pflags = $1 & ~PF_JUMPED 
				player.mo.state = S_PLAY_FRONTFLIPO
				player.pflags = $1 & ~PF_SPINNING
				S_StartSound(player.mo, sfx_tjump2)
				P_DoJump(player, false) //the jump
				player.mo.momz = $*9/10
				//xmom speed boost
				if player.isxmomentum
					P_SetObjectMomZ(player.mo, (player.speed/16) + (player.mo.momz))
				end
				//shieldz
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND
					P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
					S_StartSound(player.mo, sfx_wdjump)
					jumpdust(player.mo, 12*player.mo.scale, MT_DUST)
					jumpdust(player.mo, 16*player.mo.scale, MT_DUST)
				end
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_THUNDERCOIN
					P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
					S_StartSound(player.mo, sfx_s3k45)
					jumpdust(player.mo, 14*player.mo.scale, MT_SUPERSPARK)
				end
				
				if player.mo.eflags & MFE_UNDERWATER
					jumpdust(player.mo, 5 << FRACBITS, MT_MEDIUMBUBBLE)
				else
					jumpdust(player.mo, 5*player.mo.scale, MT_DUST)
				end
			end
			
			//third jump
			if player.jumpnumber == 2 
			and player.justjumped == 0 
			and not (P_PlayerInPain(player))
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
				player.mo.state = S_PLAY_FRONTFLIPT 
				player.justjumped = 1 
				player.jumpnumber = 3 
				player.pflags = $1 & ~PF_SPINNING
				player.pflags = $1 & ~PF_JUMPED
				S_StartSound(player.mo, sfx_tjump3)
				P_DoJump(player, false) //the jump
				player.mo.momz = $*4/5
				
				if player.isxmomentum
					P_SetObjectMomZ(player.mo, (player.speed/15) + (player.mo.momz))
				end
				//shield
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND
					P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
					S_StartSound(player.mo, sfx_wdjump)
					jumpdust(player.mo, 12*player.mo.scale, MT_DUST)
					jumpdust(player.mo, 16*player.mo.scale, MT_DUST)
				end
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_THUNDERCOIN
					P_SetObjectMomZ(player.mo, 3*FRACUNIT, true)
					S_StartSound(player.mo, sfx_s3k45)
					jumpdust(player.mo, 14*player.mo.scale, MT_SUPERSPARK)
				end
				if player.mo.eflags & MFE_UNDERWATER
					jumpdust(player.mo, 5 << FRACBITS, MT_MEDIUMBUBBLE)
				else
					jumpdust(player.mo, 5*player.mo.scale, MT_DUST)
				end
				player.pflags = $1 & ~PF_JUMPED
			end
			player.jumpcheck = 0
			player.usedown = 1 	
		end
		
		if P_IsObjectOnGround(player.mo)
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.jumpnumber = 0
		end
		
		//jump whenever
		if not P_IsObjectOnGround(player.mo)
		and not (player.pflags & PF_JUMPED)
		and (player.cmd.buttons & BT_JUMP)
		and player.usedown == 0
		and not (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.pflags = $|PF_JUMPED
			player.pflags = $1 & ~PF_THOKKED
			if player.jumpnumber == 0
				player.jumpnumber = 1
			end
		end	
		
		//making sure things dont get fuckd
		if not (player.pflags & PF_JUMPED) 
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.jumpcheck = 0 
		end
		
		//reset jumps if carried
		if player.powers[pw_carry]
		or player.powers[pw_carry] == CR_MACESPIN
			player.jumpcheck = 0 
			player.jumpnumber = 0
		end
		
		//self explanatory
		if not (player.pflags & PF_JUMPED) 
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.jumpcheck = 0 
		end
		
		//stop freaking out when you jump the second you hit the ground
		if (player.mo.eflags & MFE_JUSTHITFLOOR)
		and player.cmd.buttons & BT_JUMP
			player.jumpnumber = 1
		end
		
		//you too
		if (player.mo.eflags & MFE_JUSTHITFLOOR)
		and player.pflags & PF_JUMPED
		or P_IsObjectOnGround(player.mo) and player.pflags & PF_JUMPED
			player.jumpnumber = 1
		end	
	end
end)

//rolling time
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.mo.skin == "dummie")
	and player.playerstate == PST_LIVE 
		if srb2p return end //nobody can roll dipstick
		
		//time to start rolling on the ground lol
		if not (player.powers[pw_carry] == CR_NIGHTSMODE) //fuck nights mode lol
			if player.speed <= 5*player.mo.scale
			and not (player.pflags & PF_SPINNING)
				player.charability2 = CA2_NONE
			else 
				player.charability2 = CA2_SPINDASH
			end
			if player.pflags & PF_STARTDASH
				player.pflags = $1 & ~PF_STARTDASH
				player.pflags = $1 & ~PF_SPINNING
				player.mo.state = S_PLAY_STND 
			end
			
			if player.canuncrl == nil
			or P_IsObjectOnGround(player.mo)
				player.canuncrl = 0
				player.forcestop = 0
				player.attrac = 0
			end
			
			if (player.pflags & PF_THOKKED)
			and not P_IsObjectOnGround(player.mo)
				player.spindown = 1
			end
			
			//recurl
			if (player.cmd.buttons & BT_SPIN)
			and not (P_PlayerInPain(player))
			and not P_IsObjectOnGround(player.mo)
			and not (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_THOKKED)
			and not (player.powers[pw_carry])
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and player.spindown == 0
			and player.canrecurl == 0
				local attraclook = P_LookForEnemies(player, false, false)
				player.mo.target = attraclook
				player.mo.tracer = attraclook
				S_StartSound(player.mo, sfx_spindm)
				player.pflags = $|PF_SPINNING
				player.mo.state = S_PLAY_ROLL
				if (player.pflags & PF_JUMPED)
				and not ((player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT and attraclook and attraclook.valid)
					player.pflags = $1 & ~PF_JUMPED
				end
				player.spindown = 1
				//shields
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT and player.jumpnumber != 3
					if attraclook and attraclook.valid
						player.pflags = $|PF_SHIELDABILITY
						player.jumpnumber = 1
						player.homing = 3*TICRATE
						player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, attraclook.x, attraclook.y)
						S_StartSound(player.mo, sfx_s3k40)
					end					
				end
				
				if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL //fast drop	
				or (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
					if (player.mo.momz <= -2*FRACUNIT) //use it while falling at a certain speed
						P_SetObjectMomZ(player.mo, -15*FRACUNIT, true)
					else //use it while going up
						P_SetObjectMomZ(player.mo, -20*FRACUNIT)
					end
					player.pflags = $1|PF_SHIELDABILITY
					if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP
						S_StartSound(player.mo, sfx_s3k44)
					end
					player.canuncrl = 1
				elseif (player.powers[pw_shield] & SH_FORCE) //momentum fucker
					S_StartSound(mo, sfx_ngskid)
					player.pflags = $1|PF_SHIELDABILITY
					player.mo.momx = $*4/5
					player.mo.momy = $*4/5
					if player.forcestop == 0
						player.mo.momz = 0
						player.forcestop = 1
					end
				elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_FLAMEAURA //gain speed 
					if player.forcestop == 0
						P_InstaThrust(player.mo, player.mo.angle, player.speed + (player.speed/6)) 
						player.forcestop = 1
						if player.speed > 0
							player.pflags = $1|PF_SHIELDABILITY
							S_StartSound(player.mo, sfx_s3k43)
						end
					end
				elseif (player.powers[pw_shield] & SH_NOSTACK) == SH_ARMAGEDDON
					jumpdust(player.mo, 12*player.mo.scale, MT_SUPERSPARK)
					P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EXPLODE)
					player.mo.momx = $*1/2
					player.mo.momy = $*1/2
					P_SetObjectMomZ(player.mo, 15*FRACUNIT)
					P_NukeEnemies(player.mo, player.mo, 800*player.mo.scale)
					P_FlashPal(player, PAL_NUKE, 10)
					player.powers[pw_shield] = SH_NONE
					S_StartSound(player.mo, sfx_bkpoof)
					P_StartQuake(20*FRACUNIT, 5)
				end
			end
			
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_BUBBLEWRAP and (player.pflags & PF_THOKKED)
				player.pflags = $ & ~PF_THOKKED
				player.pflags = $|PF_SPINNING
				player.mo.state = S_PLAY_ROLL
				player.canuncrl = 0
			end
			
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT  
				if(player.pflags & PF_SHIELDABILITY)
				and player.mo.momz > 6*FRACUNIT
					P_SetObjectMomZ(player.mo, 6*FRACUNIT)
					player.pflags = $ & ~PF_SHIELDABILITY
				end
				if player.homing != 0
					player.canuncrl = 1
				else
					player.canuncrl = 0
				end
			end
			
			if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
			and player.pflags & PF_SHIELDABILITY
				local floor = P_FloorzAtPos(player.mo.x, player.mo.y, player.mo.z, player.mo.height)
				local z = player.mo.z
				if (player.mo.eflags&MFE_VERTICALFLIP)
					z = player.mo.z+player.mo.height
					if player.mo.ceilingz == floor
						floor = player.mo.floorz
					else
						floor = player.mo.ceilingz
					end
				end
				if abs(z-floor) <= abs(player.mo.momz)
					P_ElementalFire(player, true)
					S_StartSound(player.mo, sfx_s3k4c)
					player.pflags = $ & ~PF_SHIELDABILITY
				end
				if player.mo.momz > 0
					player.mo.momz = $ * -1
				end
			end

			
			//Uncurl
			if (player.cmd.buttons & BT_SPIN)
			and player.spindown == 0
			and (player.pflags & PF_SPINNING)
			and not (player.pflags & PF_SHIELDABILITY)
			and not (player.powers[pw_carry])
			and not (player.pflags & PF_THOKKED)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not P_IsObjectOnGround(player.mo)
			and player.canuncrl == 0
				if player.jumpnumber == 0
					player.jumpnumber = 1
				end
				player.pflags = $1 & ~PF_SPINNING
				player.spindown = 1
				player.mo.state = S_PLAY_FALL
			end
			//extra check
			if (player.pflags & PF_SPINNING)
			and (player.cmd.buttons & BT_SPIN)
			and player.spindown == 0
			and player.canuncrl == 0
				if player.jumpnumber == 0
					player.jumpnumber = 1
				end
				player.pflags = $1 & ~PF_SPINNING
				player.spindown = 1
				player.mo.state = S_PLAY_FALL
			end
		end
	end
end)

//floor uncurl
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.mo.skin == "dummie")
	and player.playerstate == PST_LIVE
		player.mo._prevspin = $!=nil and $ or false
		player.mo._spintime = (player.cmd.buttons & BT_SPIN) and ($ and $+1 or 1) or 0
		if (player.pflags & PF_SPINNING) and player.mo._prevspin and P_IsObjectOnGround(player.mo) and player.mo._spintime == 1
			player.pflags = $1 & ~PF_SPINNING
			player.mo.state = S_PLAY_RUN
		end
		player.mo._prevspin = player.pflags & PF_SPINNING
	end
end)

local BattleFuncSet = false
addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
	BattleFuncSet = true

	CBW_Battle.SkinVars["dummie"] = {
 		weight = 80,
 		shields = 1,
		special = CBW_Battle.Action.CombatRoll,
		func_priority_ext = CBW_Battle.Action.CombatRoll_Priority,
 		guard_enabled = true,
 		guard_frame = 6,
 		func_guard_trigger = CBW_Battle.GuardFunc.Parry,
 		func_priority = CBW_Battle.Priority_FullCommon,
 		func_priority_ext = PriorityFunction
	}
end)